
struct ems_move {		/* for ems's move call */
	long len;
	char stype;	/* 0=conv mem, 1=ems */
	int shandle;	/* handle, if ems, else 0 */
	int soffset;	/* offset in page, 0-16k, or offset part of ptr */
	int spage;	/* ems starting page, or segment part of ptr */
	char dtype;	/* 0=conv mem, 1=ems */
	int dhandle;	/* handle, if ems, else 0 */
	int doffset;	/* offset in page, 0-16k, or offset part of ptr */
	int dpage;	/* ems starting page, or segment part of ptr */
};

int ems_bx, ems_dx;
int hand = -7;
#define make_ptr(seg, ofs)	((char *) ((((long) seg) << 16) | ofs))
#define SZ	((unsigned int) 40000L)
char *orig, *copy, *malloc();


main()
{
	int ver, contig, i;
	char *p;
	unsigned int sz = SZ;
	long j;

	printf("TRYEMS test program tests EMS 4.0 Move Memory call.\n");
	printf("Copyright 1992 Lugaru Software Ltd.  (412) 421-5911.\n");
	printf("All Rights Reserved.\n\n");
	ver = try_ems();
	if (!ver)
		err("No EMS installed.");
	printf("EMS version %d.%d installed.\n", ver / 16, ver % 16);
	if (ems_call(0x4100))
		err("Error determining page frame.");
	printf("Page frame at %04x:%04x.\n\n", ems_bx, 0);
	if (ems_call(0x4200))
		err("Error getting free memory.");
	contig = ems_bx;
	printf("%d of %d pages are free.\n", contig, ems_dx);
	printf("Allocate %d pages of 16kb each.\n", contig);
	if (ems_call(0x4300, contig))
		err("Couldn't allocate pages.");
	hand = ems_dx;
	if (contig * 16384L < sz)
		sz = contig * 16384L;
	printf("Prepare %u bytes of data.\n", sz);
	orig = malloc(sz);
	copy = malloc(sz);
	if (!orig || !copy)
		err("Couldn't allocate enough conventional memory");
	memset(orig, 123, sz);
	for (i = sz / 15, p = orig; i >= 0; i--) {
		sprintf(p, "This is %u...", i);
		p += strlen(p);
	}
	printf("Copy %u bytes of data to EMS...\n", sz);
	if (func_to_ems(10L, orig, sz))
		err("Couldn't copy data to EMS.");
	for (j = 4; j * 2L + 2 < sz; j <<= 2) {
		printf("Retrieve %ld bytes of data from EMS...\n", j + 2);
		if (func_from_ems(10L + j, copy, (unsigned)(j + 2)))
			err("Couldn't retrieve data from EMS.");
		if (memcmp(orig + j, copy, (unsigned) (j + 2)))
			err("Data retrieved doesn't match.");
	}
	printf("Retrieve %u bytes of data from EMS...\n", sz);
	if (func_from_ems(10L, copy, sz))
		err("Couldn't retrieve data from EMS.");
	printf("Compare data...\n");
	if (memcmp(orig, copy, sz))
		err("Data retrieved doesn't match.");
	end();
	printf("EMS checks out.\n");
}

end()
{
	if (hand != -7) {
		printf("Freeing EMS memory.\n");
		if (ems_call(0x4500, 0, hand))
			err("Couldn't free allocated pages.");
	}
}

err(s)
char *s;
{
	printf("\n%s\n", s);
	end();
	exit(1);
}

func_to_ems(pos, p, size)	/* write function at p to ems/xms at */
long pos;			/* offset pos */
char *p;
unsigned int size;
{
	struct ems_move e;

	e.len = size;
	e.stype = 0;
	e.shandle = 0;
	e.soffset = (int) p;
	e.spage = (int) ((long) p >> 16);
	e.dtype = 1;
	e.dhandle = hand;
	e.doffset = pos & 16383;
	e.dpage = pos >> 14;
	return ems_copy(&e);
}

func_from_ems(pos, p, size)
long pos;
char *p;
unsigned int size;
{
	struct ems_move e;

	e.len = size;
	e.stype = 1;
	e.shandle = hand;
	e.soffset = pos & 16383;
	e.spage = pos >> 14;
	e.dtype = 0;
	e.dhandle = 0;
	e.doffset = (int) p;
	e.dpage = (int) ((long) p >> 16);
	return ems_copy(&e);
}
